<template>

<div>
<!-- <v-btn color="primary" @click="addEvent"> <v-icon color ='black' style="paddingLeft: 15px" small left>mdi-plus</v-icon>Nueva visita</v-btn> -->
    <v-row style="height='30%'">
    <v-col>
      <v-sheet height="64">
        <v-toolbar flat color="white">
          <v-btn outlined text medium color="grey darken-2" @click="prev" class="btnRadius_L">
            <v-icon small>mdi-chevron-left</v-icon>
          </v-btn>
          <v-btn outlined text medium color="grey darken-2" @click="next" class="btnRadius_R" >
            <v-icon small>mdi-chevron-right</v-icon>
          </v-btn>
          <v-spacer></v-spacer>
          <v-toolbar-title style="margin: 15px" v-if="$refs.calendar">
            {{ $refs.calendar.title }}
          </v-toolbar-title>
          <v-spacer></v-spacer>

            <v-btn color="primary" class ="btnRadius_L" style="padding: 0px 30px 0px 30px;" >
             <strong> Mes</strong>
            </v-btn>
            <v-btn color="#fff" class = "btnRadius_NO" style="padding: 0px 30px 0px 30px;" @click="goToSemana()" >
              <strong> Semana</strong>
            </v-btn>            
            <v-btn color="#fff" class ="btnRadius_R" style="padding: 0px 30px 0px 30px; " @click="goToDay()">
              <strong> Dia</strong>
            </v-btn>
        </v-toolbar>
      </v-sheet>
      <v-sheet height="600">
        <v-calendar
          ref='calendar'
          v-model="focus"
          :events="events"
          :event-color="getEventColor"
          event-text-color = 'black'
          color="primary"
          :type="type"
          :short-weekdays ="false"
          :short-months ="false"
          :show-month-on-first ="false"
          @change="getAsignaciones"
          @click:date="getDay"
          @click:more="getDay"
        >
         
          <template v-slot:event="{event}">
            <v-icon :color ='getColor(event.idNegocio)' style="paddingLeft: 15px" x-small left>mdi-checkbox-blank-circle</v-icon>
           <strong >{{getNumEco(event.idCeco)}} {{event.ceco}}</strong>
          </template>

        </v-calendar>


      </v-sheet>
      
    </v-col>
  </v-row>

</div>
   
</template>

<script>
import router from "@/router";
import store from "@/store";
import moment from "moment";
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
    data: () => ({
      focus: '',
      type: 'month',
      events: []
    }),
    mounted () {
      this.$refs.calendar.checkChange()
    },
    methods: {
      goToSemana (){
        var objToTravel = {
          asignaciones : this.events  
        };

        router.push({
            name : "modelo_franquicia_calendario_semana",
            params : {
              dataTransfer : serviceCommons.objectToBase64(objToTravel)
            }
        });
        

      },
      goToDay(){
        var today = moment(new Date()).format('YYYY-MM-DD');
        
        var objToTravel = {
          dia : today,
          eventos : this.events  
        };
        
        router.push({
            name : "modelo_franquicia_calendario_diario",
            params : {
              dataTransfer : serviceCommons.objectToBase64(objToTravel)
            }
        });
      },
      getNumEco(ceco){
         var res = (""+ceco).substring(2); 
        return res
      },
      getColor(negocio){
            var color  = "#000";

            if(negocio == "21"){
                color = "primary";
            }else if(negocio == "23"){ //OCC
                color = "#191970";
            }else if(negocio == "25"){ //DAZ
                color = "#32CD32";
            }

            return color;

        },
       viewDay ({ date }) {
        this.focus = date
        this.type = 'day'
      },
      getDay ({date}) {
        

        var objToTravel = {
          dia : date,
          eventos : this.events  
        };

        router.push({
            name : "modelo_franquicia_calendario_diario",
            params : {
              dataTransfer : serviceCommons.objectToBase64(objToTravel)
            }
        });
      },
      addEvent(){

        this.events.push({
          name: 'NUEVA',
          start: '2020-09-02',
          color: '#ffffff'

        })

      },
      getEventColor(event){

        var color = "#fff";


        if(event.estatus == "1"){
          color = "#ffcd0085"
        }

        return color
      },
      prev () {
        this.$refs.calendar.prev();
      },
      next () {
        this.$refs.calendar.next();
      },
      initData({start,end}){
        this.getAsignaciones();
    },
     rnd (a, b) {
        return Math.floor((b - a + 1) * Math.random()) + a
      },
      getAsignaciones(fecha){
            axios
                .post(
                    "/asignacion/secure/post/obtiene/informacionCalendario", 
                    
                     {
                       fecha : "01092020",
                        
                    }
                )
                .then((response) => {
                    if (response) {
                        if (response.status === 200) {

                            console.log(JSON.stringify(response.data.data.listaAsignaciones));
                            this.events = response.data.data.listaAsignaciones;

                            
                            

                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        },
   
    },
    
  }
</script>
<style >

.btnRadius_R{
  border-top-right-radius: 5px;
  border-bottom-right-radius: 5px;
  border-top-left-radius: 0px;
  border-bottom-left-radius: 0px;
}

.btnRadius_L{
  border-top-left-radius: 5px;
  border-bottom-left-radius: 5px;
  border-top-right-radius: 0px;
  border-bottom-right-radius: 0px;
}

.btnRadius_NO{
  border-top-right-radius: 0px;
  border-bottom-right-radius: 0px;
  border-top-left-radius: 0px;
  border-bottom-left-radius: 0px;
}



</style>